package cmd

import (
	"github.com/spf13/cobra"
	"uauth/internal/opt"
	"uauth/internal/serve"
	"uauth/internal/store/cache"
	"uauth/internal/tool"
)

func initServe() *cobra.Command {
	svc := &cobra.Command{
		Use: "svc",
		RunE: func(cmd *cobra.Command, args []string) error {
			tool.TablePrinter(opt.Cfg)
			tool.Must(cache.Init(opt.Cfg.Svc.Cache))
			return serve.Run(cmd.Context())
		},
	}

	svc.Flags().StringVar(&opt.Cfg.Svc.Address, "address", "localhost:8080", "listen address")
	svc.Flags().StringVar(&opt.Cfg.Svc.Prefix, "prefix", "/api/oauth/v2", "api prefix")
	svc.Flags().StringVar(&opt.Cfg.Svc.Cache, "cache", "lru::", "cache uri")

	return svc
}
